import { createBrowserRouter, redirect } from 'react-router-dom'
import Home from '@src/pages/Home'
import Login from '@src/pages/Login'
import ErrorPage from '@src/pages/ErrorPage'
import sso from '@src/lib/http/sso.ts'
import Index from './routes/index'

export default createBrowserRouter([
  {
    path: '/',
    Component: Home,
    ErrorBoundary: ErrorPage,
    loader: ({ request })=>{
      // 没有登录
      if (!sso.getAccessToken()){
        const {pathname,search} = location
        return redirect('/login?redirectUrl='+ encodeURIComponent(pathname+search) )
      }
  
      // 默认首页
      if (request.url.endsWith('/'))
        return redirect('/index')
      
      return null
    },
    children: [
      Index
    ]
  },
  {
    path: '/login',
    Component: Login,
    loader: ()=>{
      // 默认首页
      if (sso.getAccessToken()) 
        return redirect('/index')
      
      return null
    },
    ErrorBoundary: ErrorPage,
  }
])